unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  RTTICtrls, contnrs;

type

  TMyDaten = class (TPersistent)
  private
    FKom:String;
  published
    property Kom:String read FKom write FKom;
  end;

  { TMyDatenListe }

  TMyDatenListe =class(TPersistent)
    private
      FListe:TObjectList;
      function GetItems(Index: Integer): TMyDaten;
      function GetKom(Index: Integer): String;
      procedure SetKom(Index: Integer; const AValue: String);
    public
      constructor Create;
      destructor Destroy; override;
      procedure Add;
      property Kom[Index:Integer]:String read GetKom write SetKom;
      property Items[Index:Integer]:TMyDaten read GetItems;
  end;


  { TForm1 }

  TForm1 = class(TForm)
    BtnLese1: TButton;
    BtnLese2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    TIEdit1: TTIEdit;
    TIEdit2: TTIEdit;
    TIEdit3: TTIEdit;
    procedure BtnLese1Click(Sender: TObject);
    procedure BtnLese2Click(Sender: TObject);
    procedure Edit1EditingDone(Sender: TObject);
    procedure Edit2EditingDone(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FDatenListe:TMyDatenListe;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FDatenListe:=TMyDatenListe.Create;
  FDatenListe.Add;
  FDatenListe.Add;
  Edit1.Text:=FDatenListe.Kom[0];
  Edit2.Text:=FDatenListe.Kom[1];


  // Direkter zugriff auf TMyDaten-Objekt
  // Daten werden an den Listen- Objekt vorbei geschrieben
  TIEdit1.Link.SetObjectAndProperty(FDatenListe.Items[0],'Kom');
  TIEdit2.Link.SetObjectAndProperty(FDatenListe.Items[1],'Kom');

  // Zugriff über FDatenListe nicht möglich
  //TIEdit3.Link.SetObjectAndProperty(FDatenListe.Kom[0],'Kom',);
end;

procedure TForm1.BtnLese1Click(Sender: TObject);
begin
  Edit1.Text:=FDatenListe.Kom[0];
end;

procedure TForm1.BtnLese2Click(Sender: TObject);
begin
  Edit2.Text:=FDatenListe.Kom[1];
end;

procedure TForm1.Edit1EditingDone(Sender: TObject);
begin
    FDatenListe.Kom[0]:=Edit1.Text;
end;

procedure TForm1.Edit2EditingDone(Sender: TObject);
begin
  FDatenListe.Kom[1]:=Edit2.Text;
end;

{$R *.lfm}

{ TMyDatenListe }

function TMyDatenListe.GetKom(Index: Integer): String;
begin
  Result:=TMyDaten(FListe[Index]).FKom;
end;

function TMyDatenListe.GetItems(Index: Integer): TMyDaten;
begin
  Result:=FListe.Items[Index] as TMyDaten;
end;

procedure TMyDatenListe.SetKom(Index: Integer; const AValue: String);
begin
  TMyDaten(FListe[Index]).FKom:=AValue;
end;

constructor TMyDatenListe.Create;
begin
  FListe:=TObjectList.create(True);
end;

destructor TMyDatenListe.Destroy;
begin
  FListe.Free;
  inherited Destroy;
end;

procedure TMyDatenListe.Add;
var
  Daten:TMyDaten;
begin
  Daten:=TMyDaten.Create;
  Daten.FKom:='Hallo'+IntToStr(FListe.Count);
  FListe.Add(Daten);
end;

end.

